/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { CreateEmergencyAddressOptions, EmergencyAddress, EmergencyAddressDto, EmptyResponseDto, PagePhoneNumberProjection, PhoneNumberDto, PhonePlanDto, TestPhoneNumberOptions } from '../models';
export interface CreateEmergencyAddressRequest {
    createEmergencyAddressOptions: CreateEmergencyAddressOptions;
}
export interface DeleteEmergencyAddressRequest {
    addressId: string;
}
export interface DeletePhoneNumberRequest {
    phoneNumberId: string;
}
export interface GetEmergencyAddressRequest {
    addressId: string;
}
export interface GetPhoneNumberRequest {
    phoneNumberId: string;
}
export interface GetPhoneNumbersRequest {
    phoneCountry?: GetPhoneNumbersPhoneCountryEnum;
    page?: number;
    size?: number;
    sort?: GetPhoneNumbersSortEnum;
    since?: Date;
    before?: Date;
}
export interface TestPhoneNumberSendSmsRequest {
    phoneNumberId: string;
    testPhoneNumberOptions: TestPhoneNumberOptions;
    xTestId?: string;
}
/**
 *
 */
export declare class PhoneControllerApi extends runtime.BaseAPI {
    /**
     */
    createEmergencyAddressRaw(requestParameters: CreateEmergencyAddressRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<EmergencyAddress>>;
    /**
     */
    createEmergencyAddress(requestParameters: CreateEmergencyAddressRequest, initOverrides?: RequestInit): Promise<EmergencyAddress>;
    /**
     */
    deleteEmergencyAddressRaw(requestParameters: DeleteEmergencyAddressRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<EmptyResponseDto>>;
    /**
     */
    deleteEmergencyAddress(requestParameters: DeleteEmergencyAddressRequest, initOverrides?: RequestInit): Promise<EmptyResponseDto>;
    /**
     */
    deletePhoneNumberRaw(requestParameters: DeletePhoneNumberRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     */
    deletePhoneNumber(requestParameters: DeletePhoneNumberRequest, initOverrides?: RequestInit): Promise<void>;
    /**
     */
    getEmergencyAddressRaw(requestParameters: GetEmergencyAddressRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<EmergencyAddress>>;
    /**
     */
    getEmergencyAddress(requestParameters: GetEmergencyAddressRequest, initOverrides?: RequestInit): Promise<EmergencyAddress>;
    /**
     */
    getEmergencyAddressesRaw(initOverrides?: RequestInit): Promise<runtime.ApiResponse<Array<EmergencyAddressDto>>>;
    /**
     */
    getEmergencyAddresses(initOverrides?: RequestInit): Promise<Array<EmergencyAddressDto>>;
    /**
     */
    getPhoneNumberRaw(requestParameters: GetPhoneNumberRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<PhoneNumberDto>>;
    /**
     */
    getPhoneNumber(requestParameters: GetPhoneNumberRequest, initOverrides?: RequestInit): Promise<PhoneNumberDto>;
    /**
     */
    getPhoneNumbersRaw(requestParameters: GetPhoneNumbersRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<PagePhoneNumberProjection>>;
    /**
     */
    getPhoneNumbers(requestParameters: GetPhoneNumbersRequest, initOverrides?: RequestInit): Promise<PagePhoneNumberProjection>;
    /**
     */
    getPhonePlansRaw(initOverrides?: RequestInit): Promise<runtime.ApiResponse<Array<PhonePlanDto>>>;
    /**
     */
    getPhonePlans(initOverrides?: RequestInit): Promise<Array<PhonePlanDto>>;
    /**
     */
    testPhoneNumberSendSmsRaw(requestParameters: TestPhoneNumberSendSmsRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     */
    testPhoneNumberSendSms(requestParameters: TestPhoneNumberSendSmsRequest, initOverrides?: RequestInit): Promise<void>;
}
/**
 * @export
 * @enum {string}
 */
export declare enum GetPhoneNumbersPhoneCountryEnum {
    US = "US",
    GB = "GB",
    AU = "AU"
}
/**
 * @export
 * @enum {string}
 */
export declare enum GetPhoneNumbersSortEnum {
    ASC = "ASC",
    DESC = "DESC"
}
