/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { SmsMatchOption } from './';
/**
 * Conditions to apply to emails that you are waiting for
 * @export
 * @interface WaitForSmsConditions
 */
export interface WaitForSmsConditions {
    /**
     * ID of phone number to search within and apply conditions to. Essentially filtering the SMS found to give a count.
     * @type {string}
     * @memberof WaitForSmsConditions
     */
    phoneNumberId: string;
    /**
     * Limit results
     * @type {number}
     * @memberof WaitForSmsConditions
     */
    limit?: number | null;
    /**
     * Number of results that should match conditions. Either exactly or at least this amount based on the `countType`. If count condition is not met and the timeout has not been reached the `waitFor` method will retry the operation.
     * @type {number}
     * @memberof WaitForSmsConditions
     */
    count: number;
    /**
     * Max time in milliseconds to wait between retries if a `timeout` is specified.
     * @type {number}
     * @memberof WaitForSmsConditions
     */
    delayTimeout?: number | null;
    /**
     * Max time in milliseconds to retry the `waitFor` operation until conditions are met.
     * @type {number}
     * @memberof WaitForSmsConditions
     */
    timeout: number;
    /**
     * Apply conditions only to **unread** SMS. All SMS messages begin with `read=false`. An SMS is marked `read=true` when an `SMS` has been returned to the user at least once. For example you have called `getSms` or `waitForSms` etc., or you have viewed the SMS in the dashboard.
     * @type {boolean}
     * @memberof WaitForSmsConditions
     */
    unreadOnly?: boolean | null;
    /**
     * How result size should be compared with the expected size. Exactly or at-least matching result?
     * @type {string}
     * @memberof WaitForSmsConditions
     */
    countType?: WaitForSmsConditionsCountTypeEnum;
    /**
     * Conditions that should be matched for an SMS to qualify for results. Each condition will be applied in order to each SMS within a phone number to filter a result list of matching SMSs you are waiting for.
     * @type {Array<SmsMatchOption>}
     * @memberof WaitForSmsConditions
     */
    matches?: Array<SmsMatchOption> | null;
    /**
     * Direction to sort matching SMSs by created time
     * @type {string}
     * @memberof WaitForSmsConditions
     */
    sortDirection?: WaitForSmsConditionsSortDirectionEnum;
    /**
     * ISO Date Time earliest time of SMS to consider. Filter for matching SMSs that were received after this date
     * @type {Date}
     * @memberof WaitForSmsConditions
     */
    since?: Date | null;
    /**
     * ISO Date Time latest time of SMS to consider. Filter for matching SMSs that were received before this date
     * @type {Date}
     * @memberof WaitForSmsConditions
     */
    before?: Date | null;
}
/**
 * @export
 * @enum {string}
 */
export declare enum WaitForSmsConditionsCountTypeEnum {
    EXACTLY = "EXACTLY",
    ATLEAST = "ATLEAST"
}
/**
 * @export
 * @enum {string}
 */
export declare enum WaitForSmsConditionsSortDirectionEnum {
    ASC = "ASC",
    DESC = "DESC"
}
export declare function WaitForSmsConditionsFromJSON(json: any): WaitForSmsConditions;
export declare function WaitForSmsConditionsFromJSONTyped(json: any, ignoreDiscriminator: boolean): WaitForSmsConditions;
export declare function WaitForSmsConditionsToJSON(value?: WaitForSmsConditions | null): any;
